/*=============================================================================
	Fragmentshader for DrawComplexSurface, multi pass, FogMap.
	Experimental, unfinished, broken, unusable. Currently not in use.

	Revision history:
		* Created by Smirftsch
=============================================================================*/

uniform sampler2D Texture0;
uniform int NumLights;
uniform vec4 DrawColor;

struct LightInfo
{
    vec4 LightLocation;
    vec4 AmbientLightColor;
	vec4 DiffuseLightColor;
	vec4 LightValues;
};
uniform LightInfo gLight[32]; //FIXME! align to package size.

/*
	spotDirection.w = SpotCutOff
	LightValues contains:
    LightValues.x = float WorldLightRadius;
    LightValues.y = float quadraticAttenuation;
    LightValues.z = float SpecularIntensity;
    LightValues.w = float spotExponent;
*/
in vec2 vTexCoords;
in vec2 vLightTexCoords;
in vec3 vv_coord;
in vec3 vv_normal;
in vec3 vNormalDirection;

in mat4 vmodelMat;
/*
in mat3 vm_3x3_inv_transp;
in mat4 vprojMat;
in mat4 vviewMat;
in mat4 vmodelviewMat;
in mat4 vmodelviewprojMat;
in mat4 vviewMatinv;
*/

out vec4 FragColor;

void main (void)
{
	vec4 Color = texture(Texture0, vTexCoords);

	vec3 normalDirection = normalize(vv_normal);
	vec3 lightDirection;
	float attenuation;
	vec3 positionToLightSource;
	vec3 TotalColor;

	// Add ambient Color.
	TotalColor=gLight[0].AmbientLightColor.xyz;

	// Add draw Color.
	TotalColor+=DrawColor.xyz;

	for (int i=0; i < NumLights; i++)
	{
		// directional light?
		if (gLight[i].LightLocation.w == 0.0)
		{
			attenuation = 1.0; // no attenuation
			lightDirection = normalize(gLight[i].LightLocation.xyz);
		}
		else // point light or spotlight (or other kind of light)
		{
			positionToLightSource = gLight[i].LightLocation.xyz - vv_coord;
			float distance = length(positionToLightSource);
			lightDirection = normalize(positionToLightSource);
			attenuation = (sqrt( max( gLight[i].LightValues.y - distance*distance, 0.0f ) )/4096);//TODO: matches closely Unreal's original implementation but simplify this!
			//min((1.0/(gLight[i].linearAttenuation * distance * distance)),1.0);

			if (distance > gLight[i].LightValues.x)
				attenuation=0.0;
		}
		vec3 diffuseReflection =  attenuation * gLight[i].DiffuseLightColor.xyz * max(0.0, dot(normalDirection, lightDirection));
		TotalColor+=diffuseReflection;
	}
	TotalColor=min(TotalColor,1.0);
	FragColor = Color*vec4(TotalColor,1.0);
   //gl_FragColor = vec4(0.0,1.0,0.0,0.0);
}

// Blending translation table
/*
//PF_Modulated
//glBlendFunc( GL_DST_COLOR, GL_SRC_COLOR );
//pixel_Color * gl_FragColor

GL_ONE 						vec4(1.0)
GL_ZERO 					vec4(0.0)
GL_SRC_COLOR 				gl_FragColor
GL_SRC_ALPHA 				vec4(gl_FragColor.a)
GL_DST_COLOR 				pixel_Color
GL_DST_ALPHA 				vec4(pixel_Color.a)
GL_ONE_MINUS_SRC_COLOR		vec4(1.0) - gl_FragColor
GL_ONE_MINUS_SRC_ALPHA 		vec4(1.0  - gl_FragColor.a)
GL_ONE_MINUS_DST_COLOR 		vec4(1.0) - pixel_Color
GL_ONE_MINUS_DST_ALPHA 		vec4(1.0  - pixel_Color.a)
*/
