/*=============================================================================
	Vertexshader for DrawComplexSurface, multi pass, LightMap.

	Revision history:
		* Created by Smirftsch
=============================================================================*/

layout (location = 0) in vec3 v_coord;		// == gl_Vertex
layout (location = 3) in vec2 LightMapCoords;

layout(std140) uniform GlobalMatrices
{
	mat4 modelviewprojMat;
	mat4 modelviewMat;
};

out vec2 vLightMapCoords;
out vec4 vEyeSpacePos;

void main(void)
{
	vec4 vEyeSpacePosVertex = modelviewMat*vec4(v_coord, 1.0);
	vEyeSpacePos = vEyeSpacePosVertex;

	//Texture UV Lightmap to fragment
	vLightMapCoords	= LightMapCoords;

	gl_Position = modelviewprojMat * vec4(v_coord, 1.0);
}
