/*=============================================================================
	Vertexshader for DrawComplexSurface, multi pass, MacroTextures.

	Revision history:
		* Created by Smirftsch
=============================================================================*/

layout (location = 0) in vec3 v_coord;		// == gl_Vertex
layout (location = 6) in vec2 MacroTexCoords;

layout(std140) uniform GlobalMatrices
{
	mat4 modelviewprojMat;
	mat4 modelviewMat;
};

out vec2 vMacroTexCoords;
out vec4 vEyeSpacePos;

void main(void)
{
	vec4 vEyeSpacePosVertex = modelviewMat*vec4(v_coord, 1.0);
	vEyeSpacePos = vEyeSpacePosVertex;

	//Texture UV Fogmap to fragment
	vMacroTexCoords	= MacroTexCoords;

	gl_Position = modelviewprojMat * vec4(v_coord, 1.0);
}
