/*=============================================================================
	Geometryshader for DrawComplexSurface, single pass.

	Maybe planned to be used for BumpMap, tangent and bitangent calculation.
	Currently unused.

	Revision history:
		* Created by Smirftsch
=============================================================================*/

in vec3 vNormals[];
in vec3 vCoords[];
in vec2 vTexCoords[];

out vec3 gTangent;
out vec3 gBitangent;
out vec3 gNormals;
out vec3 gCoords;
out vec2 gTexCoords;

vec3 GetTangent(vec3 A, vec3 B, vec3 C,  vec2 Auv, vec2 Buv, vec2 Cuv)
{
	float Bv_Cv = Buv.y - Cuv.y;
	if(Bv_Cv == 0.0)
	return (B-C)/(Buv.x-Cuv.x);

	float Quotient = (Auv.y - Cuv.y)/(Bv_Cv);
	vec3 D   = C   + (B  -C)   * Quotient;
	vec2 Duv = Cuv + (Buv-Cuv) * Quotient;
	return (D-A)/(Duv.x - Auv.x);
}
vec3 GetBitangent(vec3 A, vec3 B, vec3 C,  vec2 Auv, vec2 Buv, vec2 Cuv)
{
	return GetTangent(A, C, B,  Auv.yx, Cuv.yx, Buv.yx);
}

void main(void)
{
	vec3 Tangent = GetTangent(vCoords[0], vCoords[1], vCoords[2], vTexCoords[0], vTexCoords[1], vTexCoords[2]);
	vec3 Bitangent = GetBitangent(vCoords[0], vCoords[1], vCoords[2], vTexCoords[0], vTexCoords[1], vTexCoords[2]);

	for(int i=0; i<3; ++i)
	{
		gTangent = Tangent;
		gBitangent = Bitangent;
		gNormals = vNormals[i];
		gTexCoords = vTexCoords[i];
		gCoords = vCoords[i];
		gl_Position = gl_in[i].gl_Position;
		EmitVertex();
	}
}
