/*=============================================================================
	Vertexshader for DrawGouraudPolygon, in 227 also DrawGouraudPolygonList.

	Revision history:
		* Created by Smirftsch
=============================================================================*/

layout (location = 0) in vec3 Coords;		// == gl_Vertex
layout (location = 2) in vec2 TexCoords;
layout (location = 3) in vec2 LightMapCoords;
layout (location = 4) in vec4 FogColor;
layout (location = 5) in vec2 DetailTexCoords;
layout (location = 6) in vec2 MacroTexCoords;
layout (location = 8) in vec4 LightColor;
layout (location = 9) in vec4 DistanceFogColor;

layout(std140) uniform GlobalMatrices
{
	mat4 modelviewprojMat;
	mat4 modelviewMat;
};

out vec4 vEyeSpacePos;
out vec4 vLightColor;
out vec4 vFogColor;
out vec4 vDistanceFogColor;
out vec2 vTexCoords;
out vec2 vDetailTexCoords;
out vec3 vCoords;

void main(void)
{
	vec4 vEyeSpacePosVertex = modelviewMat*vec4(Coords, 1.0);
	vEyeSpacePos = vEyeSpacePosVertex;

	// Point Coords
	vCoords = Coords;

	//Texture UV to fragment
	vTexCoords=TexCoords;

	// Texture UV DetailTexture
	vDetailTexCoords = DetailTexCoords;

	vLightColor	= LightColor;
	vFogColor	= FogColor;
	vDistanceFogColor = DistanceFogColor;
	gl_Position = modelviewprojMat * vec4(Coords, 1.0);
}
