layout(triangles) in;
layout(triangle_strip, max_vertices = 6) out;

layout(std140) uniform GlobalMatrices
{
	mat4 modelviewprojMat;
	mat4 modelviewMat;
};

uniform vec4 DrawColor;
uniform vec4 TexCoords[3];

out vec2 gTexCoords;
out vec4 gDrawColor;

void main()
{

	float RFX2=TexCoords[0].x;
	float RFY2=TexCoords[0].y;
	float FX2=TexCoords[0].z;
	float FY2=TexCoords[0].w;

	float U=TexCoords[1].x;
	float V=TexCoords[1].y;
	float UL=TexCoords[1].z;
	float VL=TexCoords[1].w;

	float XL=TexCoords[2].x; 
	float YL=TexCoords[2].y;
	float UMult=TexCoords[2].z; 
	float VMult=TexCoords[2].w;

	float X = gl_in[0].gl_Position.x;
	float Y = gl_in[0].gl_Position.y;
	float Z = gl_in[0].gl_Position.z;

	vec3 Position;

	// 0
	Position.x = RFX2*Z*( X - FX2);
	Position.y = RFY2*Z*( Y - FY2);
	Position.z = Z;
	gTexCoords.x = (U)*UMult;
	gTexCoords.y = (V)*VMult;

	gDrawColor=DrawColor;

	gl_Position = modelviewprojMat *  vec4(Position, 1.0);
	EmitVertex();

	// 1
	Position.x = RFX2*Z*(X + XL - FX2);
	Position.y = RFY2*Z*(Y - FY2);
	Position.z = Z;
	gTexCoords.x = (U + UL)*UMult;
	gTexCoords.y = (V)*VMult;
	gDrawColor=DrawColor;
	
	gl_Position = modelviewprojMat *  vec4(Position, 1.0);
	EmitVertex();

	// 2
	Position.x = RFX2*Z*(X + XL - FX2);
	Position.y = RFY2*Z*(Y + YL - FY2);
	Position.z = Z;
	gTexCoords.x = (U + UL)*UMult;
	gTexCoords.y = (V + VL)*VMult;
	gDrawColor=DrawColor;

	gl_Position = modelviewprojMat *  vec4(Position, 1.0);
	EmitVertex();
	EndPrimitive();

	// 0
	Position.x = RFX2*Z*( X - FX2);
	Position.y = RFY2*Z*( Y - FY2);
	Position.z = Z;
	gTexCoords.x = (U)*UMult;
	gTexCoords.y = (V)*VMult;
	gDrawColor=DrawColor;

	gl_Position = modelviewprojMat *  vec4(Position, 1.0);
	EmitVertex();

	// 2
	Position.x = RFX2*Z*(X + XL - FX2);
	Position.y = RFY2*Z*(Y + YL - FY2);
	Position.z = Z;
	gTexCoords.x = (U + UL)*UMult;
	gTexCoords.y = (V + VL)*VMult;
	gDrawColor=DrawColor;

	gl_Position = modelviewprojMat *  vec4(Position, 1.0);
	EmitVertex();

	// 3
	Position.x = RFX2*Z*(X - FX2);
	Position.y = RFY2*Z*(Y + YL - FY2);
	Position.z = Z;
	gTexCoords.x = (U)*UMult;
	gTexCoords.y = (V + VL)*VMult;
	gDrawColor=DrawColor;

	gl_Position = modelviewprojMat *  vec4(Position, 1.0);
	EmitVertex();
	EndPrimitive();
} 