/*=============================================================================
	Vertexshader for DrawTile.

	Revision history:
		* Created by Smirftsch
=============================================================================*/

layout (location = 0) in vec3 Coords;		// == gl_Vertex

#ifdef GL_ES
//No geometry shader for GL_ES.
layout (location = 2) in vec2 TexCoords;
layout (location = 8) in vec4 DrawColor;
layout(std140) uniform GlobalMatrices
{
	mat4 modelviewprojMat;
	mat4 modelviewMat;
};
out vec2 gTexCoords;
out vec4 gDrawColor;
#endif

void main(void)
{
#ifdef GL_ES
	gTexCoords=TexCoords;
	gDrawColor=DrawColor;
	gl_Position = modelviewprojMat * vec4(Coords, 1.0);
#else
	gl_Position = vec4(Coords, 1.0);
#endif
}

